# coding: utf-8

import os
import sys
reload(sys)
sys.setdefaultencoding('utf-8')
import tempfile
import re
import ctypes
import traceback


PYdotDLL_GLOBAL = {} # PYdotDLL global data dictionary, all global data which is used by pydotdll is stored here

def PYdotDLL_UTILS_InlineHook(where, fake):
    if type(where) is str:
        dllname, procname = where.split('.')
        hdll = ctypes.windll.kernel32.LoadLibraryA(dllname)
        where = ctypes.windll.kernel32.GetProcAddress(hdll, procname)
    if type(where) is int:
        origin = ctypes.c_long()
        ctypes.windll.PYdotDLL.InlineHook(where, fake, ctypes.byref(origin))
        return origin.value
    return 0

def PYdotDLL_HOOK_ReturnOriginFunction(*args):
    invoker = traceback.extract_stack()[-2][2]
    global PYdotDLL_GLOBAL
    return PYdotDLL_GLOBAL['hook'][invoker][0](*args)

def PYdotDLL_HOOK_Decorator(where, functype=ctypes.WINFUNCTYPE, **kw):
    def _hook(f):
        fargs = f.func_code.co_varnames[:f.func_code.co_argcount]
        gettype = lambda x: kw.get(x, ctypes.c_ulong)
        ftype = functype(gettype('restype'), *tuple([gettype(x) for x in fargs]))
        fake = ftype(f)
        origin = PYdotDLL_UTILS_InlineHook(where, fake)
        if origin:
            origin = ftype(origin)
        global PYdotDLL_GLOBAL
        if not PYdotDLL_GLOBAL.has_key('hook'):
            PYdotDLL_GLOBAL['hook'] = {}
        PYdotDLL_GLOBAL['hook'][f.__name__] = [origin,fake]

        def AKUMA(*args, **kw):
            print 'Go home, akuma will eat you. hahaaa !!'
        return AKUMA
    return _hook

HOOKDecorator = PYdotDLL_HOOK_Decorator
OriginFunction = PYdotDLL_HOOK_ReturnOriginFunction

# Todo:
if __name__ == '__m123ain__':
    print 'ooh! here is not entry.'
else:

    # Ensure and Open Console
    ctypes.windll.kernel32.AllocConsole()
    sys.stderr = sys.stdout = open("CONOUT$", "w", 0)
    sys.stdin = open('CONIN$', 'r')
    print 'Test Console .'

    newpath = tempfile.mkdtemp('-cookies')
    def Filter_QueryValueEx(lpValueName, lpData, lpcbData, isWchar):
        if lpValueName and lpValueName.lower() == 'cookies':
            needsize = ctypes.cast(lpcbData, ctypes.POINTER(ctypes.c_int32)).contents
            if lpData == 0:
                needsize.value = 1024*2
            else:
                tmptype = ctypes.ARRAY((isWchar and ctypes.c_wchar or ctypes.c_char), 1024*2)
                path = ctypes.cast(lpData, ctypes.POINTER(tmptype)).contents
                path.value = newpath
                needsize.value = isWchar and (2*len(path.value)) or (len(path.value))

    @HOOKDecorator('advapi32.RegQueryValueExW', lpValueName=ctypes.c_wchar_p)
    def RegQueryValueExW(hKey, lpValueName, lpReserved, lpType, lpData, lpcbData):
        ret = OriginFunction(hKey, lpValueName, lpReserved, lpType, lpData, lpcbData)
        Filter_QueryValueEx(lpValueName, lpData, lpcbData, True)
        return ret

    @HOOKDecorator('advapi32.RegQueryValueExA', lpValueName=ctypes.c_char_p)
    def RegQueryValueExA(hKey, lpValueName, lpReserved, lpType, lpData, lpcbData):
        ret = OriginFunction(hKey, lpValueName, lpReserved, lpType, lpData, lpcbData)
        Filter_QueryValueEx(lpValueName, lpData, lpcbData, False)
        return ret
